
/**
 * Classe Aluno.
 * Classe que modela de forma muito simples a 
 * informao e comportamento relevante de um aluno.
 * 
 * @author Antonio Nestor Ribeiro
 * @version 2006/03/20
 */
public class Aluno {
    // instance variables 
    private int numero;
    private int nota;
    private String nome;

    /**
     * Constructores para a classe Aluno
     */
    public Aluno() {
      this.numero = 0;
      this.nota = 0;
      this.nome = "";  
    }
    
    public Aluno(int numero, int nota, String nome) {
        this.numero = numero;
        this.nota = nota;
        this.nome = nome;
    }
    

    public Aluno(Aluno umAluno) {
        this.numero = umAluno.getNumero();
        this.nota = umAluno.getNota();
        this.nome = umAluno.getNome();
    }     
    
    public int getNumero() {
        
        return this.numero;
    }
    
    public int getNota() {
        
        return this.nota;
    }
    
    public String getNome() {
        
        return this.nome;
    }
    
    
    public void setNota(int novaNota) {
        this.nota = novaNota;
    }
    
   public void setNumero(int numero) {
       this.numero = numero;
   }
   
   public void setNome(String nome) {
       this.nome = nome;
   }
   
   
    /**
     * Implementao do mtodo toString
     * comum na maioria das classes Java
     * 
     * @return     uma string com a informao textual do objecto aluno
     */
    public String toString() {
        StringBuffer sb= new StringBuffer();
        
        sb.append("Numero: ");
        sb.append(this.numero+"\n");
        sb.append("Nome: ");
        sb.append(this.nome+"\n");
        sb.append("Nota: ");
        sb.append(this.nota+"\n");
        
        return sb.toString();
        
        //embora obrigue a maior esforo de escrita, esta implementao
        // mais eficiente que a normal
        //return("Numero:" + this.numero + "Nome:"+ this.nome + "Nota:" + this.nota);
        
        }
        
        /**
         * Implementao do mtodo de igualdade entre dois Aluno
         * 
         * @param  umAluno   aluno que  comparado com o receptor
         * ** * @return      booleano true ou false
         * ** * */
         public boolean equals(Object umA) {
             if (umA != null && (umA.getClass().getName()).equals("Aluno") ) {
               Aluno umAluno = (Aluno) umA;    
               return(this.nome.equals(umAluno.getNome()) && this.nota == umAluno.getNota() 
                      && this.numero == umAluno.getNumero());
             }         
             else
               return false;
         }
         
         
  
        public Object clone() {
            return new Aluno(this);
        }
     
}
