import java.util.*;

/**
 * Primeira implementao de uma turma de alunos.
 * Assume que a turma  mantida num HashMap.
 * 
 * @author Antnio Nestor Ribeiro
 * @version 2006/04/10
 */
public class Turma
{
	private String designacao;
	private HashMap lstalunos; //Numero -> Aluno
	
	
	

	/**
	 * Constructor for objects of class Turma
	 */
	public Turma()
	{
		this.designacao = new String();
		this.lstalunos = new HashMap();
		
	}
	
	public Turma(String designacao, int capacidade) {
         this.designacao = designacao;
         this.lstalunos = new HashMap(capacidade);
    }

    
    public String getDesignacao() {
        return this.designacao;
    }
    
    public int getOcupacao() {
        
        return this.lstalunos.size();
    }
    
   
    
    
    /**
	 * 
	 * Em futuras verses desta classe poderemos fazer internamente a 
	 * gesto das situaes de erro. Neste momento assume-se que a 
	 * pr-condio  verdadeira.
	 * 
	 * Este mtodo dever ser reescrito em futuras implementaes 
	 * para evitar potenciais quebras de encapsulamento.
	 * 
	 */
    public void insereAluno(Aluno umAluno) {
    
        if (umAluno != null) {
          
          Aluno novo = new Aluno(umAluno);  
          // Aluno novo = (Aluno)(umAluno.clone());
          //Integer i = new Integer(umAluno.getNumero());
          this.lstalunos.put(new Integer(umAluno.getNumero()),novo);
        }
    }
        
    /**
	 * Mtodo toString por questes de compatibilizao com as restantes
	 * classes do Java.
	 * 
	 * Como o toString  estrutural e a classe Aluno tem esse mtodo 
	 * implementado o resultado  o esperado.
	 * 
	 */
    public String toString() {
        StringBuffer sb = new StringBuffer();
        
        sb.append("Designao: "); sb.append(this.designacao+"\n");
        sb.append("Alunos: "+"\n"); sb.append(this.lstalunos.toString());
        
        return sb.toString();
    }       
    
    
    //Outros mtodos:
    //a) verificar se um aluno existe na turma
    
    public boolean existeAluno(int numero) {
        return this.lstalunos.containsKey(new Integer(numero));
    }    
    
    //b) remover aluno dado o nmero
    
    public void removeAluno(int numero) {
        this.lstalunos.remove(new Integer(numero));
    }
    
    
    //c) inserir um conjunto de alunos na turma
    
}
